# 
# Janosik - Wieloplatformowa odpowiednik programu Patnik 
#
# Copyright (C) 2002, 2003 Janosik Development Team
# 
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

"""Klasa udostpniajca templajty dokumentw.

	Wszystkie (prawie) dokumenty ZUS-owskie maj w Janosiku
	swoje templaty na postawie ktrych tworzone s wypenione
	danymi dokumenty. Templajty te s przechowywane w formacie 
	kxml w plikach tmpl/*.tmpl."""

import KXML
from os.path import isfile, join, abspath
import os
import re
import copy


class TMPL:
	"""Klasa udostpniajca templajty dokumentw.

	Wszystkie (prawie) dokumenty ZUS-owskie maj w Janosiku
	swoje templaty na postawie ktrych tworzone s wypenione
	danymi dokumenty. Templajty te s przechowywane w formacie 
	kxml w plikach tmpl/*.tmpl."""

	def __init__(self, dir = None):
		if not dir:
			dir = 'tmpl'
		self.lista = {}
		polacz = lambda f, d = dir: join(d, f)
		for path in filter(isfile, map(polacz, os.listdir(dir))):
			a = re.findall("(\w*)\.tmpl$", path)
			if a:
				self.lista[a[0]] = path

	
	def __wyczysc(self, pola):
		for section in pola[2]:
			for pole in section[2]:
				pole[2][0] = ' ' * int(pole[1]['kedu_length'])
	
	
	def nowy_dokument(self, typ):
		if not self.lista[typ][1]:
			self.lista[typ][1][:] = []
		dokument = KXML.wczytaj(self.lista[typ])
		self.__wyczysc(dokument[2][0])
		return dokument[2][0] # Zwracamy tylko pola
	
	
	def lista_dostepnych(self):
		return self.lista.keys()


