#!/usr/bin/env python

# 
# Janosik - Wieloplatformowa odpowiednik programu Patnik 
#
# Copyright (C) 2002, 2003 Janosik Development Team
# 
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

"""Modu weryfikujcy dokumenty.

	"""

import KXML
import misc
import sys
import ce
import os.path

def _add(slownik, nazwa, wartosc):
	slownik[nazwa] = wartosc

def _slownik(pola):
	"""Tworzymy sownik pl w dokumencie, indeksowany nazw."""
	slownik = {}
	f = lambda t, s = slownik: _add(s, t[1]['name'], t[2][0])
	for section in pola[2]:
		map(f, section[2])
	return slownik

def weryfikuj_pole(pole, typ, slownik):
	nazwa = pole[1]['name']
	wartosc = pole[2][0]
	if nazwa in ce.tablica_wer[typ]:
		for warunek in ce.tablica_wer[typ][nazwa]:
			if not warunek[0](wartosc, slownik, *warunek[2]):
				print '\t%s: %s - [%s]' %(nazwa, warunek[1], wartosc)

def weryfikuj_pola(pola):
	typ = 'zus' + pola[1]['name']
	if typ in ce.tablica_wer:
		print typ
		slownik = _slownik(pola)
		for section in pola[2]:
			for pole in section[2]:
				weryfikuj_pole(pole, typ, slownik)

def weryfikuj_plik(file):
	print file
	dokument = KXML.wczytaj(file)
	for pola in dokument[2]:
		weryfikuj_pola(pola)


def weryfikuj(dir):
	if os.path.exists(dir) and not os.path.isdir(dir):
		raise IOError, 'Obiekt nie jest katalogiem: %s' % outfile

	misc.walktree(dir, weryfikuj_plik)


def uzycie(nazwa):
	print "Skadnia: %s katalog_do_weryfikacji" % nazwa


def main():
	if not len(sys.argv) == 2:
		uzycie(sys.argv[0])
		sys.exit(2)
	
	try:
		weryfikuj(sys.argv[1])
	except IOError:
		uzycie(sys.argv[0])
		sys.exit(1)


if __name__ == "__main__":
	main()
