# 
# Janosik - Wieloplatformowa odpowiednik programu Patnik 
#
# Copyright (C) 2002, 2003 Janosik Development Team
# 
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

"""Klasa udostpniajca waciwoci pl dokumentw.

	Dane te s wycigane z templajtw dokmentw.
	S to np. dugoci, opisy pl. Dane te s tak pobierane,
	gdy nie s one przechowywane razem z dokumentami
	dla zaoszczdzenia miejsca."""


import TMPL


class wlasciwosci:
	def __init__(self, tmpl = None):
		self.lista = {}
		if not tmpl:
			self.tmpl = TMPL.TMPL()
		else:
			self.tmpl = tmpl

	def __add(self, slownik, nazwa, wartosc):
		slownik[nazwa] = wartosc

	def __slownik(self, pola):
		"""Tworzymy sownik pl w dokumencie, indeksowany nazw."""
		slownik = {}
		f = lambda t, a = self.__add, s = slownik: a(s, t[1]['name'], t[1])
		map(f, pola[2])
		for section in pola[2]:
			map(f, section[2])
		return slownik
		

	def __dok(self, dokument):
		if dokument not in self.lista.keys():
			pola = self.tmpl.nowy_dokument(dokument)
			slownik = self.__slownik(pola)
			self.lista[dokument] = (pola, slownik)
			
		return self.lista[dokument]

	
	def atrybut(self, dokument, nazwa, attr):
		dok = self.__dok(dokument)
		if attr not in dok[1][nazwa]:
			return None
		return dok[1][nazwa][attr]

